/**
 * Implementiert eine Queue auf Basis einer doppelt
 * verketteten Liste. 
 */
public class LagerQueue implements IObjectQueue {
	protected class Node{
		protected Object nodeData;
		protected Node nextNode;
		
		Node(Node next){
			nextNode = next;
		}
		
		Node(Node next, Object data){
			nextNode = next;
			nodeData = data;
		}
		
		void setNextNode(Node next){
			nextNode = next;
		}
		
		void setData(Object data){
			nodeData = data;
		}
		
		Node getNextNode(){
			return nextNode;
		}
		
		Object getData(){
			return nodeData;
		}
	}
	
	
	protected Node head;
	
	/* (non-Javadoc)
	 * @see IObjectQueue#push(java.lang.Object)
	 */
	public void push(Object obj){
		if (head == null) head = new Node(null, obj);
		else {
			Node actNode = head;
			while(actNode.getNextNode() != null){
				actNode = actNode.getNextNode();
			}
			// Jetzt ist actNode der letzte Knoten
			actNode.setNextNode(new Node(null, obj));
			// Jetzt ist der neue Knoten hinten angehngt			
		}
	}
	
	/* (non-Javadoc)
	 * @see IObjectQueue#pop()
	 */
	public Object pop(){
		// kein Knoten da
		if (head == null) return null;

		Node res = head;
		head = res.getNextNode();
		// ehemaliger Frontknoten ausgekettet
		return res.getData();
		// Der ehemalig head wird gabagecollectet
	}
	
	/* (non-Javadoc)
	 * @see IObjectQueue#top()
	 */
	public Object top(){
		if (head == null) return null;
		else return head.getData();
	}
}
